#include "decl_effets.h"

void lumiere(unsigned char ID, unsigned char typ, unsigned int r, unsigned int v, unsigned int b, D3DVECTOR direction, float distance, LPDIRECT3DDEVICE9 *_obj_Direct3DDevice) {

	D3DLIGHT9 lumiere;
	ZeroMemory(&lumiere, sizeof(D3DLIGHT9));

	switch(typ) {

		case 0:
			lumiere.Type = D3DLIGHT_POINT;
		break;
		case 1:
			lumiere.Type = D3DLIGHT_SPOT;
		break;
		case 2:
			lumiere.Type = D3DLIGHT_DIRECTIONAL;
		break;
		default :
			lumiere.Type = D3DLIGHT_DIRECTIONAL;
		break;
	}

	lumiere.Diffuse.r = r;
	lumiere.Diffuse.g = v;
	lumiere.Diffuse.b = b;

	lumiere.Direction.x = direction.x;
	lumiere.Direction.y = direction.y;
	lumiere.Direction.z = direction.z;

	lumiere.Range = distance;

	(*_obj_Direct3DDevice)->SetLight(ID, &lumiere);

}

void Init_lumiere(LPDIRECT3DDEVICE9 *_obj_Direct3DDevice) {

	//indique d'inclure la lumire dans le rendu total de la scne
	(*_obj_Direct3DDevice)->SetRenderState(D3DRS_LIGHTING, TRUE);

	//activation de la lumire ambiante
	(*_obj_Direct3DDevice)->SetRenderState(D3DRS_AMBIENT, 0x00202020);

}

void allumer_lum(unsigned char ID, LPDIRECT3DDEVICE9 *_obj_Direct3DDevice) {

	(*_obj_Direct3DDevice)->LightEnable(ID, TRUE);
}
