#include "decl_vect_matr.h"

D3DVECTOR normalisation(D3DVECTOR vecteur) {

	float normale = (float)sqrt(vecteur.x * vecteur.x + vecteur.y * vecteur.y + vecteur.z * vecteur.z);

	if (!normale) {

		D3DVECTOR vect_nul = {0.0f, 0.0f, 0.0f};
		return vect_nul;
	}

	D3DVECTOR norm = {vecteur.x / normale, vecteur.y / normale, vecteur.z / normale};

	return norm;
}

D3DVECTOR soustraction(D3DVECTOR a, D3DVECTOR b) {

	D3DVECTOR s = {a.x - b.x, a.y - b.y, a.z - b.z};

	return s;
}

D3DVECTOR produit_vectoriel(D3DVECTOR a, D3DVECTOR b) {
	D3DVECTOR p = {a.y * b.z - a.z * b.y, a.z * b.x - a.x * b.z, a.x * b.y - a.y * b.x};

	return p;
}

float produit_scalaire(D3DVECTOR a, D3DVECTOR b) {
	return a.x * b.x + a.y * b.y + a.z * b.z;
}

D3DVECTOR scalaire(float s, D3DVECTOR vecteur) {

	D3DVECTOR v = {s*vecteur.x, s*vecteur.y, s*vecteur.z};

	return v;
}


D3DMATRIX identite(void) {

	// matrice identite
	D3DMATRIX ident;
	ZeroMemory( &ident, sizeof(D3DMATRIX));

	// cration de la matrice identit
	ident._11 = ident._22 = ident._33 = ident._44 = 1;

	return ident;
}

void translation(D3DMATRIX *matrice, float x, float y, float z) {
	matrice->_41 = x;
	matrice->_42 = y;
	matrice->_43 = z;
}

void rotation_X(D3DMATRIX *matrice, float koef) {

		// rotation autour des X
	matrice->_22 = cosf(koef);
	matrice->_23 = sinf(koef);
	matrice->_32 = -sinf(koef);
	matrice->_33 = cosf(koef);

}

void rotation_Y(D3DMATRIX *matrice, float koef) {

		// rotation autour des Y
	float _cos = cosf(koef);
	float _sin = sinf(koef);
	
	matrice->_11 = _cos;
	matrice->_13 = -_sin;
	matrice->_31 = _sin;
	matrice->_33 = _cos;

}
